class postgresql::service (
                        $manage_service        = true,
                        $manage_docker_service = true,
                        $ensure                = 'running',
                        $enable                = true,
                        $version               = $postgresql::params::version_default,
                      ) inherits postgresql::params {

  #
  validate_bool($manage_docker_service)
  validate_bool($manage_service)
  validate_bool($enable)

  validate_re($ensure, [ '^running$', '^stopped$' ], "Not a valid daemon status: ${ensure}")

  $is_docker_container_var=getvar('::eyp_docker_iscontainer')
  $is_docker_container=str2bool($is_docker_container_var)

  if( $is_docker_container==false or
      $manage_docker_service)
  {
    if($manage_service)
    {
      service { $postgresql::params::servicename[$version]:
        ensure => $ensure,
        enable => $enable,
      }
    }
  }
}
